/*******************************************************************************
  Company:
    Microchip Technology Inc.

  File Name:
    delay.h

  Summary:
    

  Description:
    General Delay rouines

 *******************************************************************************/

//DOM-IGNORE-BEGIN
/*******************************************************************************
Copyright (c) <2014> released Microchip Technology Inc.  All rights reserved.

Microchip licenses to you the right to use, modify, copy and distribute
Software only when embedded on a Microchip microcontroller or digital signal
controller that is integrated into your product or third party product
(pursuant to the sublicense terms in the accompanying license agreement).

You should refer to the license agreement accompanying this Software for
additional information regarding your rights and obligations.

SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
(INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
 *******************************************************************************/
//DOM-IGNORE-END

#ifndef __DELAY_H_
#define __DELAY_H_

#if !defined(SYS_CLK_FrequencyInstructionGet)
#error SYS_CLK_FrequencyInstructionGet() must be defined.
#endif

#if defined(__XC16) || defined(__XC32)
void Delay10us(uint32_t dwCount);
void DelayMs(uint16_t ms);
#else
#define Delay10us(x)                                                      \
    do                                                                    \
    {                                                                     \
        unsigned long _dcnt;                                              \
        _dcnt=x*((unsigned long)(0.00001/(1.0/SYS_CLK_FrequencyInstructionGet())/6)); \
        while(_dcnt--);                                                   \
    } while(0)
void DelayMs(uint16_t ms);
#endif

#endif
